
use builtin;
use str;

set edit:completion:arg-completer[pkgcruft] = {|@words|
    fn spaces {|n|
        builtin:repeat $n ' ' | str:join ''
    }
    fn cand {|text desc|
        edit:complex-candidate $text &display=$text' '(spaces (- 14 (wcswidth $text)))$desc
    }
    var command = 'pkgcruft'
    for word $words[1..-1] {
        if (str:has-prefix $word '-') {
            break
        }
        set command = $command';'$word
    }
    var completions = [
        &'pkgcruft'= {
            cand --color 'enable/disable color support'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand -V 'Print version'
            cand --version 'Print version'
            cand diff 'Compare reports'
            cand ignore 'Show ignore information'
            cand replay 'Replay reports'
            cand scan 'Scan for QA issues'
            cand show 'Show various information'
        }
        &'pkgcruft;diff'= {
            cand -r 'Restrict by report set'
            cand --reports 'Restrict by report set'
            cand -p 'Package restrictions'
            cand --pkgs 'Package restrictions'
            cand --color 'enable/disable color support'
            cand --sort 'Sort reports'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pkgcruft;ignore'= {
            cand --repo 'Target repo'
            cand --color 'enable/disable color support'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pkgcruft;replay'= {
            cand -r 'Restrict by report set'
            cand --reports 'Restrict by report set'
            cand -p 'Package restrictions'
            cand --pkgs 'Package restrictions'
            cand -s 'Restrict by scope'
            cand --scopes 'Restrict by scope'
            cand -R 'Reporter to use'
            cand --reporter 'Reporter to use'
            cand --format 'Format string for the format reporter'
            cand --stats 'Sorting variant for the stats reporter'
            cand --color 'enable/disable color support'
            cand --sort 'Sort reports'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pkgcruft;scan'= {
            cand -f 'Enable package filtering'
            cand --filters 'Enable package filtering'
            cand -j 'Parallel jobs to run'
            cand --jobs 'Parallel jobs to run'
            cand --exit 'Exit status triggers'
            cand --repo 'Target repo'
            cand -R 'Reporter to use'
            cand --reporter 'Reporter to use'
            cand --format 'Format string for the format reporter'
            cand --stats 'Sorting variant for the stats reporter'
            cand -r 'Restrict by report set'
            cand --reports 'Restrict by report set'
            cand --color 'enable/disable color support'
            cand -F 'Disregard ignore settings'
            cand --force 'Disregard ignore settings'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pkgcruft;show'= {
            cand --color 'enable/disable color support'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand checks 'Show checks'
            cand reports 'Show reports'
        }
        &'pkgcruft;show;checks'= {
            cand --repo 'Target repo'
            cand --color 'enable/disable color support'
            cand -i 'Output extended information'
            cand --info 'Output extended information'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pkgcruft;show;reports'= {
            cand --repo 'Target repo'
            cand -r 'Restrict by report set'
            cand --reports 'Restrict by report set'
            cand --color 'enable/disable color support'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
    ]
    $completions[$command]
}
